#pragma once

#include "MemoryObject.h"
#include "threads/CIOCriticalSection.h"

#include <windows.h>

class CIOObject : public MemoryObject
{
public:
    ~CIOObject();  // L2CacheD 0x00427E80

    virtual void OnTimer(int id);                                                           // L2CacheD 0x00414B40
    virtual void OnTimerCallback(int id);                                                   // L2CacheD 0x0047F4A0
    virtual void OnWaitCallback();                                                          // L2CacheD 0x00401070
    virtual void OnIOCallback(BOOL success, DWORD transferred, LPOVERLAPPED lpOverlapped);  // L2CacheD 0x0047F540
    virtual BOOL PostObject(DWORD id);                                                      // L2CacheD 0x00414B50

    static bool SetShortTimeStamp(long* pTimeVar, DWORD nAdditional);  // L2CacheD 0x0047F5D0
    static void TimerDispatch();                                       // L2CacheD 0x00481710

protected:
    CIOObject();
    virtual void TimerExpired(int id);  // L2CacheD 0x00426C50

    bool RegisterWait(HANDLE handle);          // L2CacheD 0x00482650
    bool AddTimer(unsigned int time, int id);  // L2CacheD 0x004828C0

private:
    static CIOCriticalSection g_globalLockTimer;  // L2CacheD 0x026846B0
    static volatile LONG s_objectInTimer;         // L2CacheD 0x02684698
};
