#include "data/CReadItemData.h"

#include "utils/dbg/StackGuard.h"

#include <windows.h>

#include <cstring>

// L2CacheD 0x004858A0
CReadItemData::CReadItemData(int itemId, const wchar_t* itemName, int defaultPrice)
    : m_itemId(itemId)
    , m_defaultPrice(defaultPrice)
{
    guard(L"CReadItemData::CReadItemData(int itemId, const wchar_t *itemName, int defaultPrice)", L"CReadItemData::CReadItemData(int itemId, const wchar_t *itemName, int defaultPrice) (exit)", TEXT(__FILE__), __LINE__);

    ::memset(m_itemName, 0, sizeof(m_itemName));
    ::wcscpy(m_itemName, itemName);

    unguard();
}

// L2CacheD 0x00485900
CReadItemData::~CReadItemData()
{
    guard(L"CReadItemData::~CReadItemData", L"CReadItemData::~CReadItemData (exit)", TEXT(__FILE__), __LINE__);
}
