#pragma once

#include "CIOObject.h"

class CIOSocket;

class CIOServer : public CIOObject
{
public:
    ~CIOServer();  // L2CacheD 0x00480590

    void Release(const char* file, int line, ORTs nWorkType, bool flag) override;               // L2CacheD 0x004803E0
    void OnWaitCallback() override;                                                             // L2CacheD 0x0047F8D0
    void OnIOCallback(BOOL bSuccess, DWORD dwTransferred, LPOVERLAPPED lpOverlapped) override;  // L2CacheD 0x00480610

protected:
    CIOServer();  // L2CacheD 0x00480510
    virtual CIOSocket* CreateSocket(SOCKET socket, sockaddr_in* address) = 0;
    bool Create(int port);  // L2CacheD 0x00482740
    SOCKET getSocket() const;

private:
    static void operator delete(void* ptr);  // inlined inside L2CacheD 0x00481260
    void Close();                            // L2CacheD 0x0047F870

private:
    static long s_nAlloc;  // L2CacheD 0x026846A4
    SOCKET m_hSocket;
    HANDLE m_hAcceptEvent;
};
