#pragma once

#include "CIOObject.h"

#include <utils/cstdint_support.h>

class CIOSocket;
class CIOBuffer;

class CPacket : public CIOObject
{
public:
    static CPacket* Alloc();  // inlined
    static void FreeAll();    // L2CacheD 0x00480840

    void Release(const char* file, int line, ORTs nWorkType, bool flag) override;               // L2CacheD 0x00480710
    void OnIOCallback(BOOL bSuccess, DWORD dwTransferred, LPOVERLAPPED lpOverlapped) override;  // L2CacheD 0x004812A0

protected:
    CPacket();   // L2CacheD 0x00427F30
    ~CPacket();  // L2CacheD 0x00427FA0

private:
    static void operator delete(void* ptr);  // L2CacheD inlined inside deleting destructor 0x00427F60
    static void* operator new(size_t size);  // L2CacheD 0x00427EB0

public:
    static long g_nPendingPacket;  // L2CacheD 0x02684624

#ifdef L2CACHED
    int m_createTime;
    int m_handleTime;
    int m_deleteTime;
    int m_packetType;
#endif  // #ifdef L2CACHED
    CIOSocket* m_pSocket;
    CIOBuffer* m_pBuf;
    typedef bool (*PacketFunc)(CIOSocket*, const uint8_t* packet);
    PacketFunc m_pFunc;

protected:
    static long s_nAlloc;  // L2CacheD 0x026846D0
};
