#pragma once

#include "threads/ThreadIndices.h"

#include <windows.h>

#include "utils/cstdint_support.h"

class CThreadManager
{
public:
    static void RegisterThisThread(ThreadIndices threadIndex);  // L2CacheD 0x0045B330
    static void SetThisThreadAsMainThread();                    // L2CacheD 0x0045B2B0
    static bool isMainThread();                                 // L2CacheD 0x0045B2D0
    static bool isListenThread();                               // L2CacheD 0x0045B2F0

    static uint32_t GetIOThreadNumber();                   // L2CacheD 0x0045B310
    static void SetIOThreadNumber(int maxIOThreadNumber);  // L2CacheD 0x0045B320
    static uint32_t GetMaxIOThreadNumber();                // L2CacheD 0x0047F3A0

    static void SetThread(ThreadIndices index, HANDLE thread);  // L2CacheD 0x0045B350
    static HANDLE GetThread(ThreadIndices index);               // L2CacheD 0x0045B360

private:
    static HANDLE s_threads[ThreadIndex_MaxCount];  // L2CacheD 0x021E6F50
    static uint32_t s_IOThreadNumber;               // L2CacheD 0x021E6FA4
};
