#pragma once

#include "threads/ThreadIndices.h"

struct LockFrame
{
    volatile int m_deep;
    int m_recurent;
    const wchar_t* m_lockName;
    int m_line;
};

class LockStack
{
public:
    LockStack();
    ~LockStack();

    void Push(int recurent, int deep, const wchar_t* lockName, int line);     // L2CacheD 0x00434740
    void Pop(int recurent, int m_deep, const wchar_t* unlockName, int line);  // L2CacheD 0x00434920

    long lockSize() const;                    // inlined in original binary
    const LockFrame& frame(int index) const;  // inlined in original binary

private:
    LockFrame m_lockFrames[10000];
    volatile long m_lockCount;
};

inline long LockStack::lockSize() const
{
    return m_lockCount;
}

inline const LockFrame& LockStack::frame(int index) const
{
    return m_lockFrames[index];
}

extern LockStack g_stacks[ThreadIndex_MaxCount];  // L2CacheD 0x02350010
