#pragma once

#include <windows.h>
#include <deque>
#include <string>
#include <utils/cstdint_support.h>

class CSQLQueue
{
public:
    CSQLQueue();   // 0x00411C90
    ~CSQLQueue();  // 0x00420A60

    void SpaceUsed(bool force);                // 0x004114E0
    bool ExecSQL();                            // 0x00411850
    bool PushSQL(const wchar_t* format, ...);  // 0x00411D00

    static void Job();  // 0x00403D60

    static int getDbSize();        // inlined
    static int getUnusedDbSize();  // inlined

private:
    static uint64_t s_lastSpaceCheck;  // 0x019D6988
    static int s_dbSize;               // 0x019D698C
    static int s_dbUnusedSize;         // 0x019D6990

    CRITICAL_SECTION m_lock;
    std::deque<std::wstring> m_queue;  // TODO PORT ME: string with custom allocator
};

extern CSQLQueue g_sqlPollingQueue;  // 0x01BD543C
