#pragma once

#include "network/CIOSocket.h"
#include "network/SocketStatus.h"

class CLogSocket : public CIOSocket
{
public:
    typedef bool (*PacketHandler)(CIOSocket*, const uint8_t*);

public:
    CLogSocket(SOCKET socket, const PacketHandler* packetHandlers);  // 0x0040D4E0
    ~CLogSocket();                                                   // 0x0040D560

    static void* operator new(size_t size);  // 0x0040D140
    static void operator delete(void* ptr);  // 0x0040D190

    void Release(const char* file, int line, ORTs nWorkType, bool flag) override;  // 0x0040D700
    void Send(const char* format, ...);                                            // 0x0040D5F0

public:
    static const int HANDLERS_NUMBER = 3;
    static const PacketHandler s_packetHandlers[HANDLERS_NUMBER];  // 0x0042D89C

protected:
    void OnClose();  // 0x0040D570
    void OnRead();   // 0x0040D870

private:
    static bool packet0_SendMsg(CIOSocket* socket, const uint8_t* packet);      // 0x0040D430
    static bool packet1_CheckStatus(CIOSocket* socket, const uint8_t* packet);  // 0x0040D450
    static bool packet2_TestPacket(CIOSocket* socket, const uint8_t* packet);   // 0x0040D4C0

private:
    static long s_nAlloc;  // 0x01BD4FC0

    int m_socket;
    int field_2;
    const PacketHandler* m_packetHandlers;
    SocketStatus m_status;
    int m_packetSize;
};
