#pragma once

#include "CIOObject.h"

#include <utils/cstdint_support.h>

class CIOSocket;
class CIOBuffer;

class CPacket : public CIOObject
{
public:
    CPacket();   // inlined
    ~CPacket();  // inlined

    static CPacket* Alloc();  // inlined
    static void FreeAll();    // 0x00409B50

    void Release(const char* file, int line, ORTs nWorkType, bool flag) override;               // 0x00409A20
    void OnIOCallback(BOOL bSuccess, DWORD dwTransferred, LPOVERLAPPED lpOverlapped) override;  // 0x0040A460

private:
    static void operator delete(void* ptr);  // 0x004092C0
    static void* operator new(size_t size);  // inlined

public:
    static long g_nPendingPacket;  // 0x01BD3BB0

    CIOSocket* m_pSocket;
    CIOBuffer* m_pBuf;
    typedef bool (*PacketFunc)(CIOSocket*, const uint8_t* packet);
    PacketFunc m_pFunc;

private:
    static long s_nAlloc;  // 0x01BD3E0C
};
