#pragma once

#include "network/CIOServer.h"

class CServerSocket;

class CServer : public CIOServer
{
public:
    typedef CServerSocket* (*SocketFactory)(SOCKET socket);

public:
    CServer();   // 0x0040F080
    ~CServer();  // 0x0040F0F0

    static void operator delete(void* ptr);  // inlined inside 0x0040F430

    void Release(const char* file, int line, ORTs nWorkType, bool flag) override;  // 0x0040F300

    void Run(int port, SocketFactory allocator, bool restricted, int reader, int worker);  // 0x0040F170

    HANDLE thread() const;
    void setThread(HANDLE thread);

protected:
    CIOSocket* CreateSocket(SOCKET newSocket, sockaddr_in* address) override;  // 0x0040F200

private:
    static long s_nAlloc;  // 0x01BD5028

    HANDLE m_thread;
    int field2;
    SOCKET m_socket;
    HANDLE m_someHandle;
    CRITICAL_SECTION m_lock;
    SocketFactory m_allocator;
    bool m_restrict;
};

extern CServer g_logServer;  // 0x01BD3B68
