#include "threads/CThreadManager.h"
#include "threads/ThreadLocalStorage.h"

HANDLE CThreadManager::s_threads[ThreadIndex_MaxCount];  // 0x019D6934
uint32_t CThreadManager::s_IOThreadNumber;               // 0x019D6968

// 0x00405FD0
void CThreadManager::SetThisThreadAsMainThread()
{
    tls::SetCurrentThreadIndex(ThreadIndex_Main);
}
// 0x00405FF0
bool CThreadManager::isMainThread()
{
    uint32_t threadIndex = tls::GetCurrentThreadIndex();
    return threadIndex == ThreadIndex_Main;
}

// 0x00406010
bool CThreadManager::isListenThread()
{
    uint32_t threadIndex = tls::GetCurrentThreadIndex();
    return threadIndex == ThreadIndex_ListenThread;
}

// 0x00406050
void CThreadManager::RegisterThisThread(ThreadIndices threadIndex)
{
    tls::SetCurrentThreadIndex(threadIndex);
}

// 0x00406030
uint32_t CThreadManager::GetIOThreadNumber()
{
    return CThreadManager::s_IOThreadNumber;
}

// 0x00406040
void CThreadManager::SetIOThreadNumber(uint32_t maxIOThreadNumber)
{
    CThreadManager::s_IOThreadNumber = maxIOThreadNumber;
}

// 0x004086B0
uint32_t CThreadManager::GetMaxIOThreadNumber()
{
    SYSTEM_INFO systemInfo;
    ::GetSystemInfo(&systemInfo);
    uint32_t coreBasedMax = 2 * systemInfo.dwNumberOfProcessors;
    const uint32_t IO_THREAD_MAX = 8;
    return min(coreBasedMax, IO_THREAD_MAX);
}

// 0x00406070
void CThreadManager::SetThread(ThreadIndices index, HANDLE threadId)
{
    CThreadManager::s_threads[index] = threadId;
}

// 0x00406080
HANDLE CThreadManager::GetThread(ThreadIndices index)
{
    return CThreadManager::s_threads[index];
}
