#pragma once

#include "threads/ThreadIndices.h"

#include <windows.h>

#include <queue>

#include <utils/cstdint_support.h>

class CIOObject;

namespace Threads
{

// Main thread loop
void MessageLoop_common(HACCEL hAccTable);   // 0x00403AE0
void MessageLoop_mailing(HACCEL hAccTable);  // 0x00403B50

// CliLog thread
uint32_t __stdcall CliLogThread(void*);  // 0x0040CEC0
void CliLogThread_common();              // 0x0040C4B0
void CliLogThread_mailing();             // 0x0040C420

// LogD server thread
uint32_t __stdcall ServerListeningThread(void*);  // 0x00403C20
void ServerListeningThread_common();              // inlined
void ServerListeningThread_mailing();             // inlined

// SQL queue
uint32_t __stdcall SqlQueueThread(void*);  // 0x00404340
void SqlQueueThread_mailing();             // 0x004042A0
void SqlQueueThread_common();              // 0x00404330

// Performance monitor
uint32_t __stdcall PerfMonitorThread(void*);  // 0x00404270
void PerfMonitorThread_mailing();             // 0x004041D0
void PerfMonitorThread_common();              // 0x00404260
extern HANDLE PerfMonitor_s_thread;           // 0x00455C1C

// BCP
uint32_t __stdcall BCPThread(void* bcpSlot);  // 0x00404420
void BCPThread_mailing(int bcpSlot);          // 0x00404370
void BCPThread_common(int bcpSlot);           // 0x00404410
extern HANDLE BCPThread_s_threads[10];        // 0x00455C70

// IO thread
void CreateIOThread(uint32_t maxIOThread);       // 0x0040AF40
void WaitThread();                               // 0x0040ABB0
uint32_t __stdcall IOThread(void* threadIndex);  // 0x0040AF00
void IOThread_common(ThreadIndices index);       // 0x0040AD20
void IOThread_mailing(ThreadIndices index);      // 0x0040AE60

extern HANDLE s_timer;                     // 0x01BD3BB8
extern bool g_bTerminating;                // 0x01BD3BBC
extern std::vector<HANDLE> g_vHandle;      // 0x01BD3D3C
extern std::vector<CIOObject*> g_vObject;  // 0x01BD3D4C

}  // namespace Threads
