#pragma once

#include "ui/CLog.h"

#include <windows.h>

class CExceptionInit
{
public:
    CExceptionInit();   // 0x00403670
    ~CExceptionInit();  // 0x00420960

    static void LogException(const wchar_t* format, ...);  // 0x00403760
    static LONG ExceptionFilter(void* ex)
    {
        return ExceptionFilter((_EXCEPTION_POINTERS*)(ex));
    }
    static int ExceptionFilter(EXCEPTION_POINTERS* ex);  // 0x00403920
    static void SendExceptionLog(bool fatal);            // 0x00403970

public:
    static wchar_t s_logPath[MAX_PATH];  // 0x00441968
    static time_t s_startTime;           // 0x00441B70

private:
    static LONG WINAPI RecordExceptionInfo(struct _EXCEPTION_POINTERS* exceptionInfo);                                       // 0x00403540
    static void RestoreTopLevelFilter();                                                                                     // 0x00403650
    static void InstallTopLevelFilter();                                                                                     // 0x00403630
    static bool SendMail(const char* ipAddress, const char* mailServer, const char* mailFrom, const wchar_t* errorLogPath);  // 0x00402A00
    static bool SendFile(SOCKET socket, const wchar_t* fileToSend);                                                          // 0x00402940

private:
    static LPTOP_LEVEL_EXCEPTION_FILTER s_oldFilter;  // 0x00441960
    static CRITICAL_SECTION s_lock;                   // 0x00441B74
    static int s_errorReported;                       // 0x00441B90
};

extern CExceptionInit g_exeptionHalder;  // 0x00441BB0

#define _BEFORE                                                                                                                                                                                                                                                                                                                \
    __try                                                                                                                                                                                                                                                                                                                      \
    {

#define _AFTER_FIN                                                                                                                                                                                                                                                                                                             \
    }                                                                                                                                                                                                                                                                                                                          \
    __except (CExceptionInit::ExceptionFilter(_exception_info()))                                                                                                                                                                                                                                                              \
    {                                                                                                                                                                                                                                                                                                                          \
        CExceptionInit::LogException(L"*%S:%d(%S) exception\n", __FILE__, __LINE__, __TIMESTAMP__);                                                                                                                                                                                                                            \
        g_winlog.FlushLogFile();                                                                                                                                                                                                                                                                                               \
        CExceptionInit::SendExceptionLog(true);                                                                                                                                                                                                                                                                                \
    }
