#include "utils/dbg/CallStack.h"
#include "ui/CLog.h"
#include "threads/ThreadLocalStorage.h"

int CallStack::s_threadStackSizes[ThreadIndex_MaxCount + 1];  // 0x00441828
FuncList CallStack::s_functions[ThreadIndex_MaxCount];        // 0x00434D08

// 0x00403A70
void CallStack::Push(const wchar_t* funcName)
{
    uint32_t index = tls::GetCurrentThreadIndex();

    // TODO: FIXME: check for index range and stack size!
    FuncList& funcNames = CallStack::s_functions[index];

    int stackSize = CallStack::s_threadStackSizes[index];
    funcNames[stackSize] = funcName;

    CallStack::s_threadStackSizes[index]++;
}

// 0x00403AC0
void CallStack::Pop()
{
    uint32_t index = tls::GetCurrentThreadIndex();
    CallStack::s_threadStackSizes[index]--;
}

// 0x004034C0
void CallStack::ReportCallStack()
{
    uint32_t threadIndex = tls::GetCurrentThreadIndex();

    g_winlog.Add(LOG_ERROR, L"--- call stack ---");

    int stackSize = CallStack::s_threadStackSizes[threadIndex];
    if (stackSize <= 0)
    {
        return;
    }

    int stackIndex = 0;
    FuncList& funcNames = CallStack::s_functions[threadIndex];
    for (int i = 0; i < stackSize; ++i)
    {
        const wchar_t* funcName = funcNames[i];
        g_winlog.Add(LOG_ERROR, L"[%d] %s", stackIndex, funcName);
        ++stackIndex;
    }
}
