#include "utils/dbg/LockStack.h"
#include "ui/CLog.h"

#include <windows.h>

LockStack g_stacks[ThreadIndex_MaxCount];  // 0x019D7E28

LockStack::LockStack()
{
}

LockStack::~LockStack()
{
}

// 0x00405EF0
void LockStack::Push(int recurent, int deep, const wchar_t* lockName, int line)
{
    if (m_lockCount >= 10000)
    {
        g_winlog.Add(LOG_ERROR, L"Lock stack is small?? -_-;;; kuooo");
    }

    m_lockFrames[m_lockCount].m_line = deep;
    m_lockFrames[m_lockCount].m_deep = recurent;
    m_lockFrames[m_lockCount].m_lockName = lockName;
    m_lockFrames[m_lockCount].m_line = line;

    ::InterlockedIncrement(&m_lockCount);
}

// 0x00405F60
void LockStack::Pop(int /*recurent*/, int /*deep*/, const wchar_t* /*unlockName*/, int /*unlocker*/)
{
    if (m_lockCount == 0)
    {
        g_winlog.Add(LOG_ERROR, L"NO WAY!!! trying to unlock the unlocked lock -_-;;; kuooo mansei");
    }

    ::InterlockedDecrement(&m_lockCount);

    m_lockFrames[m_lockCount].m_line = 0;
    m_lockFrames[m_lockCount].m_deep = 0;
    m_lockFrames[m_lockCount].m_lockName = NULL;
    m_lockFrames[m_lockCount].m_line = 0;
}
